#include "rnd.h"	/* My random-number generator */
#include <pthread.h>
#include <curses.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <string.h>

#define FIGURE		'@'
#define BLANK		' '
#define SHOOT		'*'
#define ENEMY		'X'
#define ENEMY2		'O'
#define MAXLEVEL	10
#define GAME_SPEED_N	2000000
#define TIMER_SPEED	(GAME_SPEED/40000)
#define GOVER		" Booooooooom HaHaHa Game Over "
#define END_STRING	" Yeah, you defeat the funky beasts "
#define SPACES_STRING	"                          "
#define FIGURE_LINK()	(struct fig *) malloc(sizeof(struct fig))

#define DRAW_ENEMY2()	  mvwaddch(ScreenWindow, enemy2->y, enemy2->x,\
                          enemy2->Figure);

#define FIGURE_DELETE() figure->Figure = BLANK; DrawFigure(figure);\
                        figure->Figure = FIGURE
#define SPEED(x)	for(i=0;i<x;i++)
#define SHOOT_DIR(x,y)	for(k=0;k<x;k++) {\
                              y;\
                              DrawFigure(shoot);\
                        }
#define DRAW_BOR(x,y,bor) mvaddch(x,y,bor)
#define TEST_ENEMYX(x)    temp = mvwinch(ScreenWindow,figure->y, x);\
                          if((A_CHARTEXT & temp) == ENEMY || \
			  (A_CHARTEXT & temp == ENEMY2)) Crash()
#define TEST_ENEMYY(y)	  temp = mvwinch(ScreenWindow, y, figure->x);\
			  if((A_CHARTEXT & temp) == ENEMY || \
			  (A_CHARTEXT & temp == ENEMY2)) Crash()
#define PRINT_STRING(s)	  mvwaddstr(ScreenWindow, LINES/2,\
			  ((COLS/2)-(strlen(s))/2), s)

enum direction {LEFT, RIGHT, UP, DOWN};

struct fig {
	int x;
	int y;
	char Figure;
} *figure, *shoot, *enemy, *enemy2;

int main __P((int argc, char *argv[]));
void ExitGame __P((int));
void DrawFigure __P((struct fig *));
void MoveFigure __P((void));
void PressKey __P((int));
void MoveDirection __P((void));
void TestPos __P((void));
void Crash __P((void));
void Shoot __P((void));
void DrawEnemy __P((void));
void DrawEnemy2 __P((void));
void NewLevel __P((void));
void TestTimer __P((void));
void GameEnd __P((void));

WINDOW *ScreenWindow;

char bufsize[BUFSIZ];
int Direction, LastDirection, i, k, l, input, temp, temp2, level = 1;
long GAME_SPEED;
int timervar, timer;
pthread_t KeyMove, AutoMove;

int main(int argc, char *argv[]) {
	if(argc == 2) {
		GAME_SPEED = (atoi(argv[1]))*700000;
	}
	
	else {
		GAME_SPEED = GAME_SPEED_N;
	}
	
	timervar = TIMER_SPEED;
	timer = TIMER_SPEED;

	initscr();
	clear();
	cbreak();
	noecho();
	nonl();
	scrollok(ScreenWindow,FALSE);
	keypad(stdscr, TRUE);

	srand(getpid()); /* Init random seed */

        signal(SIGQUIT, ExitGame);
	setbuf(stdout, bufsize);

	ScreenWindow = newwin(0,0,0,0);
	box(ScreenWindow, ACS_VLINE, ACS_HLINE);

	figure = FIGURE_LINK();
	figure->x = COLS/2; /* Startposition */
	figure->y = LINES/2;
	figure->Figure = FIGURE;

	shoot = FIGURE_LINK();
	enemy = FIGURE_LINK();
	enemy2 = FIGURE_LINK();
	enemy->Figure = ENEMY;

	Direction = LEFT; /* Startdirection */

	refresh();
	NewLevel();

	wrefresh(ScreenWindow);

	pthread_create(&KeyMove, NULL, (void *) MoveFigure, NULL);
	pthread_create(&AutoMove, NULL, (void *) MoveDirection, NULL);

	pthread_join(KeyMove, NULL);
	pthread_join(AutoMove, NULL);
	
	return 0;
}

void GameEnd(void) {
	PRINT_STRING(END_STRING);
	sleep(2);
	ExitGame(0);
}

void TestTimer(void) {
	if(timer == 0) {
		timervar += TIMER_SPEED;
		timer = timervar;
			
		if(level == MAXLEVEL) {
			GameEnd();
		}

		level++;
		NewLevel();
	}

	else {
		timer--;
	}
}

void NewLevel(void) {
	mvwprintw(ScreenWindow,LINES/2,COLS/2-10,
		"   Prepare for level %d   ",level);
	wrefresh(ScreenWindow);
	sleep(2);
	PRINT_STRING(SPACES_STRING);
}

void DrawEnemy2(void) {
   if(enemy2->x != figure->x) {
	enemy2->Figure = ENEMY2;
	enemy2->x = rnd2(78)+1;
	enemy2->y = rnd2(23)+1;
	DRAW_ENEMY2();
	SPEED(GAME_SPEED);
   }
}

void DrawEnemy(void) {
	if(enemy->x != figure->x) {
	   enemy->x = rnd2(78)+1;
	   enemy->y = rnd2(23)+1;
	   mvwaddch(ScreenWindow, enemy->y, enemy->x, enemy->Figure);
	}
}

void Shoot(void) {
	if(input == BLANK) {
		shoot->x = figure->x;
		shoot->y = figure->y;
		input = LastDirection;
		Direction = LastDirection;
		shoot->Figure = SHOOT;		
		DrawEnemy();

		switch(input) {
			case LEFT	: SHOOT_DIR(COLS,shoot->x--);
					  SPEED(GAME_SPEED/2);
					  shoot->Figure = BLANK;
					  shoot->x = figure->x;
					  SHOOT_DIR(COLS,shoot->x--);
					  DRAW_BOR(shoot->y,0,ACS_VLINE);
					  break;
			case RIGHT	: SHOOT_DIR(COLS,shoot->x++);
					  SPEED(GAME_SPEED/2);
					  shoot->Figure = BLANK;
					  shoot->x = figure->x;
					  SHOOT_DIR(COLS,shoot->x++);
					  DRAW_BOR(shoot->y,COLS-1,ACS_VLINE);
					  break;
			case UP		: SHOOT_DIR(LINES,shoot->y--);
					  SPEED(GAME_SPEED);
					  shoot->Figure = BLANK;
					  shoot->y = figure->y;
					  SHOOT_DIR(LINES,shoot->y--);
					  DRAW_BOR(0,shoot->x,ACS_HLINE);
					  break;
			case DOWN	: SHOOT_DIR(LINES,shoot->y++);
					  SPEED(GAME_SPEED);
					  shoot->Figure = BLANK;
					  shoot->y = figure->y;
					  SHOOT_DIR(LINES,shoot->y++);
					  DRAW_BOR(LINES-1,shoot->x,ACS_HLINE);
					  break;
		}
	}
}

void Crash(void) {
	pthread_cancel(KeyMove);
	
	box(ScreenWindow, ACS_VLINE, ACS_HLINE);
	PRINT_STRING(GOVER);
	wmove(ScreenWindow,0,0);
	wrefresh(ScreenWindow);
	sleep(2);
	ExitGame(0);
}

void TestPos(void) {
	switch(Direction) {
		case LEFT	: TEST_ENEMYX(figure->x-1); break;
		case RIGHT	: TEST_ENEMYX(figure->x+1); break;
		case UP		: TEST_ENEMYY(figure->y-1); break;
		case DOWN	: TEST_ENEMYY(figure->y+1); break;
		default		: break;
	}	

	if(figure->x < 1) Crash();
	else if(figure->x > COLS-2) Crash();
	else if(figure->y > LINES-2) Crash();
	else if(figure->y < 1) Crash();
}

void MoveDirection(void) {
   for(;;) {
	DrawEnemy2();
	TestTimer();
	switch(Direction) {
		case LEFT	: 
				  FIGURE_DELETE(); TestPos();
				  figure->x--; DrawFigure(figure); break;
		case RIGHT	: 
				  FIGURE_DELETE(); TestPos();
				  figure->x++; DrawFigure(figure); break;
		case UP		: 
				  FIGURE_DELETE(); TestPos();
				  figure->y--; DrawFigure(figure); break;
		case DOWN	: 
				  FIGURE_DELETE(); TestPos();
				  figure->y++; DrawFigure(figure); break;
		case BLANK	: break;
	}
   }
}

void MoveFigure(void) {
   for(;;) {
	switch(input = getch()) {
		case KEY_LEFT	: PressKey(LEFT); break;
		case KEY_RIGHT	: PressKey(RIGHT); break;
		case KEY_UP	: PressKey(UP); break;
		case KEY_DOWN	: PressKey(DOWN); break;
		case BLANK	: PressKey(BLANK); break;
	}
   }
}

void PressKey(int direction) {
	switch(direction) {
		case LEFT	: FIGURE_DELETE(); Direction = LEFT;
				  LastDirection = Direction;
				  figure->x--; DrawFigure(figure); break;
		case RIGHT	: FIGURE_DELETE(); Direction = RIGHT;
				  LastDirection = Direction;
				  figure->x++; DrawFigure(figure); break;
		case UP		: FIGURE_DELETE(); Direction = UP;
				  LastDirection = Direction;
				  figure->y--; DrawFigure(figure); break;
		case DOWN	: FIGURE_DELETE(); Direction = DOWN;
				  LastDirection = Direction;
				  figure->y++; DrawFigure(figure); break;
		case BLANK	: Direction = BLANK; TestPos(); Shoot(); break;
	}
}

void ExitGame (int dummy __attribute__((unused))) {
	endwin();
	free(figure);
	free(enemy);
	free(enemy2);
	free(shoot);
	exit(0);
}

void DrawFigure(struct fig *pos) {
	mvwaddch(ScreenWindow, pos->y, pos->x, pos->Figure);
	wmove(ScreenWindow, pos->y, pos->x);
	wrefresh(ScreenWindow);
}
